function waitforgui()
% wait for GUI
%
% WAITFORGUI()
%
% The function produces a window with a "Resume" button and waits until
% either the figure is closed or the button is pressed.
%

sX = 150;
sY = 60;

hFigure = figure(...
    'menuBar','none',...
    'toolBar','none',...
    'position',[0 0 sX sY],...
    'resize','off',...
    'name','Wait for GUI',...
    'numbertitle','off',...
    'visible','off',...
    'Tag','waitforgui'...
    );
movegui(hFigure,'northwest')
set(hFigure,'visible','on')

% add resume button
hButton = uicontrol(...
    'Parent',hFigure,...
    'Style','pushbutton',...
    'String','Return',...
    'Units','normalized',...
    'Callback','uiresume',...
    'Visible','on'...
    );

set(hButton,'Position',[0.1 0.1 0.8 0.8]);
% wait until button pressed
uiwait(hFigure)
if isvalid(hFigure)
    close(hFigure)
end

end